;----------------------------------------------------------------------------
; This is a simple sample program to play a tune on the synth code.
;
; MODULE: MUSIC DRIVER - DOES NOT HAVE TO BE EDITED!
;
;	COPYRIGHT 1992,1993,1994 Atari U.S. Corporation           	     
;									      
;       UNAUTHORIZED REPRODUCTION, ADAPTATION, DISTRIBUTION,                   
;       PERFORMANCE OR DISPLAY OF THIS COMPUTER PROGRAM OR                    
;       THE ASSOCIATED AUDIOVISUAL WORK IS STRICTLY PROHIBITED.               
;       ALL RIGHTS RESERVED.                        			      
;----------------------------------------------------------------------------

;----------------------------------------------------------------------------
; 	INCLUDE FILES
;----------------------------------------------------------------------------
	.include	'jaguar.inc'
	.include	'fulsyn.inc'
	.include	'synth.cnf'
;----------------------------------------------------------------------------
; 	DEFINES
;----------------------------------------------------------------------------
	TIMER	equ	$F10000
;----------------------------------------------------------------------------
; 	EXTERNALS
;----------------------------------------------------------------------------

	.extern		SYN_COPY	; start of the synth


	.extern		TABS_COPY	; start of tables

	.extern		DSPORG		; start oF DSP RAM

	.extern		VOLUME		; MIDI volume
	.extern		UEBERVOLUME	; global volume

	.extern		patches		; Patch Data

	.extern		SCORE_ADD	; ptr to the music data
	.extern		PATCHLOC	; ptr to the patches

	.extern		scoretab	;here's the music data
	.extern		SHUTDOWN
	.extern		TMR1_ISR


;----------------------------------------------------------------------------
; 	CODE SECTION
;----------------------------------------------------------------------------
	.text

; Enable sound (mute bit)

	move.l	#0, R_DAC 	 ; right DAC
	move.l	#0, L_DAC	 ; left DAC
	move.w	#$100,JOYSTICK	 ; mute bit 

; Init the DSP code

	move.l	#$00070007,D_END	; Set GOOD mode

; First we copy the Jerry code into Jerry
; The code gets loaded into the DSP at DSPORG

	move.l	#SYN_COPY,a0
	move.l	(a0)+,a1
	move.l	(a0)+,d1
	asr.l	#2,d1
	subq.l	#1,d1
translop:
	move.l	(a0)+,(a1)+
	dbra	d1,translop

; Now we copy the tables into Jerry

	move.l	#TABS_COPY,a0
	move.l	(a0)+,a1
	move.l	(a0)+,d1
	asr.l	#2,d1
	subq.l	#1,d1
tablop:
	move.l	(a0)+,(a1)+		; initialize voice table
	dbra	d1,tablop
				
	move.l	$f1b010, orglong

restart:
	move.l	#0,D_CTRL		; Turn DSP off
	move.l	#0,D_FLAGS		; Set known state

; Turn off score timer

	move.w	#0,JPIT1
	move.w	#0,JPIT1+2
	move.l	orglong, $f1b010

; S clock

	move.l	#SCLKVALUE,SCLK
	move.l	#$15,SMODE

	move.l	#MIDIVOLUME,VOLUME		; set global volume 
	move.l	#GLOBALVOLUME,UEBERVOLUME	; set global volume 


; Now it should be safe to turn on the DSP

	move.l	#DSPORG,D_PC		; Set up D_PC
	move.l	#$1,D_CTRL		; LET 'R RIP

; Now we copy the score to the score location

 	move.l	#scoretab,a0	
	move.l	#$50000,a1		; here's where we put the music data

scorelop:
	move.l	(a0)+,d0		; copy it
	move.l	d0,(a1)+
	cmp.l	#$7fffffff,d0		; $7fffffff = end of music score
	bne	scorelop

	move.l	#$50000,SCORE_ADD

; Now lets set up a patch table	

	move.l	#patches,a0		; Get number of tables...
	move.w	(a0)+,d0
	mulu.w	#20,d0			; a table contains 20 longs
	move.l	#PATCHTAB,a1

patchlop:
	move.l	(a0)+,(a1)+		; now we copy the patches
	dbra	d0,patchlop

	move.l	#PATCHTAB, PATCHLOC	; set the ptr to the patches

; Set up Timer1

	move.w	#$34,JPIT1+2
	move.w	#$114,JPIT1

	illegal

; ************************ END OF MAIN CODE ***********************



;---------------------------------------------------------------------------
;	B S S
;---------------------------------------------------------------------------

	.bss
orglong:
	ds.l	1

;____________________________________EOF____________________________________
